%define		pname mod_watch
%define		pversion 4.3
%define		dumbversion 403
%define 	bversion 121
%define		rpmrelease iworx.p1.ru

%define 	debug_package %{nil}

# Distro Statements
%define		oscode rhe%{?rhel}x

%if 0%{?rhel} <= 7
%define 	ostype RedHat Enterprise %{?rhel}.x
%endif


%if 0%{?rhel} >= 8
%define 	ostype Almalinux %{?rhel}.x
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

BuildRequires:	apr
BuildRequires:	apr-devel
BuildRequires:	apr-util
BuildRequires:	apr-util-devel
BuildRequires:  httpd-devel
BuildRequires:  libselinux-devel
Requires: 	    httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}


############### RPM ################################

Summary:	mod_watch -- Bandwidth accounting for Apache
Name:		%{pname}
Version:	%{pversion}
Release: 	%{release}
License:	GPL

Group:		System Environment/Daemons
Source0:	%{name}-%{pversion}_apache22_mod.tar.gz
Source1:	%{name}%{dumbversion}.tgz

URL:		http://www.snert.com/

Distribution:	InterWorx-HAL
Vendor:         NEXCESS.NET L.L.C
Packager:	Chris Wells <clwells@nexcess.net>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Source2:	mod_watch.conf
Patch0:         mod_watch-4.3_20090908_segfault.patch
Patch1: 	mod_watch-4.3_20100809_russian.patch
Patch2:		mod_watch-4.3_apache24.patch
Patch3:         mod_watch-4.3-disable-dynamichost.patch

%description
mod_watch is a bandwidth accounting module for Apache

%prep

[ -n %{buildroot} ] && rm -rf %{buildroot}

[ -d %{_builddir}/%{name}-%{pversion} ] && rm -rf %{_builddir}/%{name}-%{pversion}

%setup -q -n %{name}-%{pversion}

%patch0 -p1

%if 0%{?rhel} >= 6
%patch1 -p1
%endif

%patch3 -p1

%if 0%{?rhel} >= 7
%patch2 -p1
%endif

# Display compilation flags and OS with colors ;)

[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

export CC="gcc %{ccflags}"

%build

[ -f %{_sbindir}/apxs ] && APXS="%{_sbindir}/apxs"
[ -f %{_bindir}/apxs ] && APXS="%{_bindir}/apxs"

%{__make} %{?_smp_mflags} \
	-f Makefile.dso build APXS=$APXS

# build the .so
[ -f %{_sbindir}/apxs ] && %{_sbindir}/apxs -c *.lo
[ -f %{_bindir}/apxs ] && %{_bindir}/apxs -c *.lo

%install

## make the "install" dir
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_libdir}/httpd/modules
mkdir -p %{buildroot}%{_localstatedir}/lib/mod_watch
mkdir -p %{buildroot}%{_localstatedir}/lib/mod_watch/ip
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d

cp -f .libs/mod_watch.so %{buildroot}%{_libdir}/httpd/modules
cp -f apache2mrtg.pl %{buildroot}%{_bindir}
cp -f mod_watch.pl %{buildroot}%{_bindir}
cp -f %{SOURCE2} %{buildroot}%{_sysconfdir}/httpd/conf.d/0watch.conf

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d %{_builddir}/%{name}-%{pversion} ] && rm -rf %{_builddir}/%{name}-%{pversion}

%pre

%postun

[ -d %{_localstatedir}/%{name} ] &&
	rm -rf %{_localstatedir}/%{name} || :

%post

%files
%defattr(-,root,root)

%attr(0755,root,root) %{_bindir}/mod_watch.pl
%attr(0755,root,root) %{_bindir}/apache2mrtg.pl
%attr(0755,root,root) %{_libdir}/httpd/modules/mod_watch.so
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/httpd/conf.d/0watch.conf

%attr(0750,root,apache) %dir %{_localstatedir}/lib/mod_watch
%attr(0750,root,apache) %dir %{_localstatedir}/lib/mod_watch/ip

%changelog
* Mon Dec 13 2021 Tim College <tcollege@interworx.com>
- Remove ancient dynamic gcc resolution (always resulted in just 'gcc')
* Wed Dec 8 2021 Tim College <tcollege@interworx.com>
- Add Almalinux 8.x
* Thu Jan 11 2018 Paul Oehler <poehler@interworx.com>
- Enable mod_watch by default again
* Thu Nov 16 2017 Paul Oehler <poehler@interworx.com>
- Renamed watch.conf to 0watch.conf
- Disable mod_watch by default now
* Wed Nov 08 2017 Paul Oehler <poehler@interworx.com>
- Made watch.conf an rpm config file
* Tue Aug 26 2014 Matt Parmelee <mparmelee@interworx.com>
- Updated for RHEL 7.x
* Mon Aug 9 2010 Paul Oehler <poehler@interworx.com>
- added the "russian" patch to workaround errors in apache error log
* Tue Sep 8 2009 Paul Oehler <poehler@interworx.com>
- added a patch addressing a segfault mod_watch-4.3_20090908_segfault.patch
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS

